/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VDmStudyRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VDmStudy extends TableImpl<VDmStudyRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_dm_study</code>
     */
    public static final VDmStudy V_DM_STUDY = new VDmStudy();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDmStudyRecord> getRecordType() {
        return VDmStudyRecord.class;
    }

    /**
     * The column <code>common_dd.v_dm_study.study_id</code>.
     */
    public final TableField<VDmStudyRecord, Integer> STUDY_ID = createField(DSL.name("study_id"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_study.study_name</code>.
     */
    public final TableField<VDmStudyRecord, String> STUDY_NAME = createField(DSL.name("study_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dm_study.study_element</code>.
     */
    public final TableField<VDmStudyRecord, Integer> STUDY_ELEMENT = createField(DSL.name("study_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_study.token_data</code>.
     */
    public final TableField<VDmStudyRecord, String> TOKEN_DATA = createField(DSL.name("token_data"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dm_study.token_config</code>.
     */
    public final TableField<VDmStudyRecord, String> TOKEN_CONFIG = createField(DSL.name("token_config"), SQLDataType.CLOB, this, "");

    private VDmStudy(Name alias, Table<VDmStudyRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDmStudy(Name alias, Table<VDmStudyRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_dm_study" as  SELECT pk AS study_id,
         name AS study_name,
         fk_element AS study_element,
         token_data,
         token_config
        FROM common_dd.t_core_study;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_dm_study</code> table reference
     */
    public VDmStudy(String alias) {
        this(DSL.name(alias), V_DM_STUDY);
    }

    /**
     * Create an aliased <code>common_dd.v_dm_study</code> table reference
     */
    public VDmStudy(Name alias) {
        this(alias, V_DM_STUDY);
    }

    /**
     * Create a <code>common_dd.v_dm_study</code> table reference
     */
    public VDmStudy() {
        this(DSL.name("v_dm_study"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VDmStudy as(String alias) {
        return new VDmStudy(DSL.name(alias), this);
    }

    @Override
    public VDmStudy as(Name alias) {
        return new VDmStudy(alias, this);
    }

    @Override
    public VDmStudy as(Table<?> alias) {
        return new VDmStudy(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmStudy rename(String name) {
        return new VDmStudy(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmStudy rename(Name name) {
        return new VDmStudy(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmStudy rename(Table<?> name) {
        return new VDmStudy(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmStudy where(Condition condition) {
        return new VDmStudy(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmStudy where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmStudy where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmStudy where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmStudy where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmStudy where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmStudy where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmStudy where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmStudy whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmStudy whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
